/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import li.netcat.print.table.*;

import java.util.*;
import java.text.*;
public class DinnerModel implements TableDataModel {
  private String[] _headers;
  private List _rows;
  private double _total;
  
  public DinnerModel() {
    _rows = new ArrayList();
    _headers = new String[]{"Produkt", "Menge", "Preis", "Total"};
    add("Brtchen", 4, 1.10);
    add("Cabernet Sauvignon", 6, 24.50);
    add("Parmesan", 1, 3.50);
    add("Mineralwasser, 1.5 Liter Pet", 6, 1.10);
    add("Kerzen", 2, 0.70);
  }
  
  public void add(String name, int amount, double price) {
    _rows.add(new String[] {name, Integer.toString(amount), format(price), format(amount*price)});
    _total += amount*price;
  }
  
  public int getRowCount() {
    return _rows.size();
  }

  public int getColumnCount() {
    return _headers.length;
  }
  
  public Object getValueAt(int rowIndex, int columnIndex) {
    return ((String[])_rows.get(rowIndex))[columnIndex];
  }
  
  public Object getValueTypeAt(int rowIndex, int columnIndex) {
    return getTypeAt(columnIndex);
  }
  
  public boolean hasHeader() {
    return true;
  }
  
  public Object getHeaderAt(int columnIndex) {
    return _headers[columnIndex];
  }
  
  public Object getHeaderTypeAt(int columnIndex) {
    return String.class;
  }

  public boolean hasFooter() {
    return true;
  }
  
  public Object getFooterAt(int columnIndex) {
    if (columnIndex == 0) {
      return "Total";
    }
    if (columnIndex == 3) {
      return format(_total);
    }
    return null;
  }
  
  public Object getFooterTypeAt(int columnIndex) {
    return getTypeAt(columnIndex);
  }

  
  //// private helpers
  
  private Object getTypeAt(int columnIndex) {
    if (columnIndex == 0) {
      return String.class;
    }
    return Number.class;
  }
  
  private static DecimalFormat format = new DecimalFormat("0.00");
  
  private String format(double value) {
    return format.format(value);
  }
}