/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;

import li.netcat.print.*;
import li.netcat.print.util.*;
import li.netcat.print.table.*;

public class GridPrintExample {
  
  public static void main(String[] args) {
    // as usual
    new PrintPreview(createPrint()).open();
  }
  
  public static Print createPrint() {
    // define some texts
    String t1 = "ein punkt richtet sich in seiner oberflche auf ohne die Absicht den zenith zu erreichen doch mit sanfter neigung gegen";
    String t2 = "die achse eines semikolons das aus seiner";
    String t3 = "hngenden lage schwingen und wie eine";
    String t4 = "schiffsschaukel in den himmel steigen knnte bis es im scheitelpunkt einen moment stillsteht wie ein ausrufezeichen";
    String t5 = "wenn auch nur im vorbergehn und ohne hoffnung je wieder hier auszuruhn (Franz Mon)";
    // define the default grid print constraints. Its column span is "reminder".
    GridPrintConstraints c = GridPrintConstraints.DEFAULT;
    // define a grid print with a horizontal and vertical gap of 20
    // for this example, we use two boxed grid prints, the inner and the outer
    GridPrint inner = new GridPrint(20, 20);
    // add a text print with a column span of 1, i.e. the next print is on the same row.
    inner.add(new TextPrint(t2), c.colSpan(1));
    // add a text at the end of the current row
    inner.add(new TextPrint(t3), c);
    // add the next text
    inner.add(new TextPrint(t4), c);
    // allocate the outer grid, also with a gap of 20
    GridPrint outer = new GridPrint(20, 20);
    outer.add(new TextPrint(t1), c.colSpan(1));
    // add the inner grid print into the outer and set the weight of this
    // column to 2.0f so that this column gets twice as much space as the first column
    outer.add(inner, c.colWeight(2.0f));
    outer.add(new TextPrint(t5), c);
    return outer;
  }
}
