/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;

import li.netcat.print.*;
import li.netcat.print.util.*;
import li.netcat.print.table.*;

public class HeaderFooterExample {
  
  public static void main(String[] args) {
    // decorate the print of the grid example with a page decorator
    new PrintPreview(new PagePrint(GridPrintExample.createPrint(), createPageDecorator())).open();
  }

  public static PageDecorator createPageDecorator() {
    return new MyPageDecorator();
  }
  
  // implementation of a page decorator
  private static class MyPageDecorator implements PageDecorator {
    private static Image LOGO = ImageLoader.loadImage("./images/Logo.gif");
    private Print _headerPrint;

    //// constructors
    
    public MyPageDecorator() {
      TextPrint textPrint = new TextPrint("ReportCat");
      textPrint.setFont(new Font(null, Font.BOLD, 14));
      ImagePrint imagePrint = new ImagePrint(LOGO, 104, 18);
      GridPrintConstraints c = GridPrintConstraints.DEFAULT;
      GridPrint gp = new GridPrint();
      gp.add(textPrint, c.colSpan(1));
      gp.add(imagePrint, c.colWidthPreferred());
      gp.add(new LinePrint());
      _headerPrint = gp;
    }
    
    // factory method that creates the header for a page
    // here, the header is always the same
    public Print createHeader(PageNumber number) {
      return _headerPrint;
    }
    
    public int getHeaderGap(PageNumber number) {
      return 20;
    }
    
    // factory method that creates the footer for a page
    public Print createFooter(PageNumber number) {
      GridPrint gp = new GridPrint();
      GridPrintConstraints c = GridPrintConstraints.DEFAULT;
      gp.add(new LinePrint());
      gp.add(new TextPrint("Copyright (c) 2003 - 2004 by NetCat Inc., all rights reserved."), c.colSpan(1));
      gp.add(new PageNumberPrint(number), c.hAlignRight().colWidthPreferred());
      return gp;
    }
    
    public int getFooterGap(PageNumber number) {
      return 10;
    }
  }
}