/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;

import li.netcat.print.*;
import li.netcat.print.util.*;

public class HtmlTableBorder implements PrintBorder {
  private static final PrintInsets MARGINS = new PrintInsets(0, 0, 0, 0, 0, 0);

  //// interface PrintBorder

  public PrintInsets getPrintInsets(Print print, Graphics g) {
    return MARGINS; 
  }

  public void paint(Print print, Graphics g, PrintInsets margins, int x, int y, int width, int height, boolean topOpened, boolean bottomOpened) {
    g.setColor(Color.white);
    if (topOpened) {
      dashLine(g, x, y, width, 1);
    }
    if (bottomOpened) {
      dashLine(g, x, y+height-1, width, 1);
    }
  }

  private void dashLine(Graphics g, int x, int y, int width, int height) {
    for (int dx = 10; dx<width; dx+=20) {
      g.fillRect(x+dx, y, 10, height);
    }
  }
}
