/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;

import li.netcat.print.table.*;

public class HtmlTableLook implements TableLook {
  private TableMargins _margins = new TableMargins(4, 4, 4, 4, 4, 4, 4, 4);
  private Color _light = new Color(212, 208, 200);
  private Color _dark = new Color(128, 128, 128);
  
  //// interface TableLook
  
  public TableMargins getTableMargins(TablePrint print, Graphics g) {
    return _margins;
  }
  
  public void paint(TablePrint print, Graphics g, int x, int y, int[] columnWidths, int[] rowHeights, int headerHeight, int footerHeight) {
    int width = _margins.calculateTotalWidth(columnWidths);
    int height = _margins.calculateTotalHeight(headerHeight, rowHeights, footerHeight);
    drawRectangle(g, x, y, width, height, _light, _dark);
    int cx = x + _margins.getLeft() - 1;
    int cy = y + _margins.getTop() - 1;
    if (headerHeight >= 0) {
      drawRectangles(g, cx, cy, columnWidths, headerHeight);
      cy += headerHeight + _margins.getHeaderGap();
    }
    for (int row=0; row<rowHeights.length; row++) {
      if (row > 0) {
        cy += _margins.getVGap();
      }
      int rowHeight = rowHeights[row];
      drawRectangles(g, cx, cy, columnWidths, rowHeight);
      cy += rowHeight;
    }
    if (footerHeight >= 0) {
      cy += _margins.getFooterGap();
      drawRectangles(g, cx, cy, columnWidths, footerHeight);
    }
  }
  
   //// private helpers
    
  private void drawRectangles(Graphics g, int x, int y, int[] columnWidths, int height) {
    for (int col=0; col<columnWidths.length; col++) {
      drawRectangle(g, x, y, columnWidths[col]+2, height+2, _dark, _light);
      x += columnWidths[col] + _margins.getHGap();
    }
  }
  
  private void drawRectangle(Graphics g, int x, int y, int width, int height, Color color1, Color color2) {
    g.setColor(color1);
    g.fillRect(x, y, width-1, 1);
    g.fillRect(x, y+1, 1, height-2);
    g.setColor(color2);
    g.fillRect(x+width-1, y, 1, height);
    g.fillRect(x, y+height-1, width-1, 1);
  }
}
