/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;

import li.netcat.print.*;
import li.netcat.print.util.*;

public class ImageLoader {
  
  private final static Component component = new Component() {};
  private final static MediaTracker tracker = new MediaTracker(component);

  public static Image loadImage(String fileName) {
    Image image = Toolkit.getDefaultToolkit().createImage(fileName);
    loadImage(image);
    return image;
  }
  
  private static void loadImage(Image image) {
    synchronized(tracker) {
      tracker.addImage(image, 0);
      try {
        tracker.waitForID(0, 0);
      } 
      catch (InterruptedException e) {
        System.out.println("INTERRUPTED while loading Image");
      }
      tracker.removeImage(image, 0);
    }
  }
}
