/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;

import li.netcat.print.*;
import li.netcat.print.util.*;

public class LinePrint implements Print {
  
  //// interface Print
  
  public Dimension getPreferredSize(Graphics g) {
    return new Dimension(1, 1);
  }
  
  public PrintIterator getPrintIterator() {
    return new LinePrintIterator();
  }
  
  //// inner classes 
  
  private static class LinePrintIterator implements PrintIterator {
    private boolean _available = true;
    
    //// interface PrintIterator
    
    public boolean hasNext() {
      return _available;
    }
  
    public Painter getNext(Graphics g, int width, int height) {
      _available = false;
      return new LinePainter(width);
    }
  }

  private static class LinePainter extends FixSizePainter {
    
    //// constructor
    
    public LinePainter(int width) {
      super(width, 1);
    }
  
    //// implementation of abstract metods
    
    public void paint(Graphics g, int x, int y) {
      g.setColor(Color.black);
      g.fillRect(x, y, super.getWidth(), super.getHeight());
    }
  }
}
