/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;

import li.netcat.print.*;
import li.netcat.print.table.*;
import li.netcat.print.util.*;

public class RotateExample {
  
  public static void main(String[] args) {
    // decorate the rotated print with header and footer
    new PrintPreview(new PagePrint(createPrint(), HeaderFooterExample.createPageDecorator())).open();
  }

  public static Print createPrint() {
    // need some elements to print
    TablePrint table = TableLineBreakExample.createTable();
    table.setFitWidth(false);
    Print image = ScaleExample.createImagePrint();
    // add them to a grid with gaps 20, 20
    GridPrint grid = new GridPrint(20, 20);
    // use constraints that puts the components in the center
    GridPrintConstraints c = GridPrintConstraints.DEFAULT.hAlignCenter();
    grid.add(table, c);
    grid.add(image, c);
    // return the ratated grid
    return new RotatePrint(grid);
  }
  
}
