/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;

import li.netcat.print.*;
import li.netcat.print.table.*;
import li.netcat.print.util.*;

public class ScaleExample {
  public static Image FLOWER = ImageLoader.loadImage("./images/Flower.gif");
  
  public static void main(String[] args)	{
    new PrintPreview(createPrint()).open();
  }
  
  public static Print createImagePrint() {
    return new ImagePrint(FLOWER, 256, 204);
  }

  public static Print createPrint() {
    // need some elements to print
    TablePrint table1 = TableLineBreakExample.createTable();
    table1.setFitWidth(false);
    TablePrint table2 = TableLineBreakExample.createTable();
    table2.setFitWidth(false);
    Print image = createImagePrint();
    // add them to a grid
    GridPrint grid = new GridPrint(20, 20);
    GridPrintConstraints c = GridPrintConstraints.DEFAULT.hAlignCenter();
    // the image should be auto scaled if it doesnt fit on the page
    grid.add(new ScalePrint(image, ScalePrint.MODE_AUTO_WIDTH), c);
    // the table 1 has a fix initial scale of 0.75 and gets also auto scaled
    grid.add(new ScalePrint(table1, 0.75, ScalePrint.MODE_AUTO_WIDTH), c);
    // the table 2 has a fix initial scale of 1.2 and gets also auto scaled
    grid.add(new ScalePrint(table2, 1.2, ScalePrint.MODE_AUTO_WIDTH), c);
    return grid;
  }
  

}
