/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import li.netcat.print.*;
import li.netcat.print.util.*;
import li.netcat.print.table.*;

public class SplitExample {
  
  public static void main(String[] args)	{
    // decorate the splitted print with header and footer
    PrintPreview preview = new PrintPreview(new PagePrint(createPrint(), HeaderFooterExample.createPageDecorator()));
    // set the default orientation to landscape
    preview.getPreviewPanel().getPrintManager().setOrientation(PrintConstants.LANDSCAPE);
    preview.open();
  }
  
  public static Print createPrint() {
    GridPrint gp = new GridPrint(20, 20);
    // add some prints of the previous examples to the grid
    gp.add(TableLineBreakExample.createPrint());
    gp.add(TableLookExample.createPrint());
    gp.add(GridPrintExample.createPrint());
    gp.add(TableColumnWidthExample.createPrint());
    gp.add(DecoratorExample.createPrint());
    gp.add(ScaleExample.createPrint());
    gp.add(RotateExample.createPrint());
    return new SplitPrint(gp);
  }
}
