/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;

import li.netcat.print.*;
import li.netcat.print.table.*;
import li.netcat.print.util.*;

public class TableColumnWidthExample {
  
  public static void main(String[] args) {
    new PrintPreview(createPrint()).open();
    //new PrintPreview(createPrint2()).open();
    //new PrintPreview(createPrint3()).open();
    //new PrintPreview(createPrint4()).open();
  }

  public static Print createPrint() {
    // create four tables
    TablePrint table1 = createTable();
    TablePrint table2 = createTable();
    TablePrint table3 = createTable();
    TablePrint table4 = createTable();
    // add them to a grid print
    GridPrint grid = new GridPrint(20, 20);
    GridPrintConstraints c = GridPrintConstraints.DEFAULT;
    // center the first table
    grid.add(table1, c.hAlign(PrintConstants.CENTER));
    // second table is left aligned
    grid.add(table2, c);
    // third table is right aligned
    grid.add(table3, c.hAlign(PrintConstants.RIGHT));
    grid.add(table4, c);
    // forth table fits the available width
    table4.setFitWidth(true);
    return grid;
  }
  
  public static Print createPrint2() {
    TablePrint table = createTable();
    // set the weight of the price column to 0 so that it doesn't get reduced
    table.setColumnWeight(1, 0.0f);
    table.setFitWidth(true);
    return table;
  }

  public static Print createPrint3() {
    TablePrint table = createTable();
    // set the minimum column width of column 1 to 100
    table.setMinimumColumnWidth(1, 100);
    table.setFitWidth(true);
    return table;
  }
  
  public static Print createPrint4() {
    TablePrint table = createTable();
    // set the column width constraint that the column 1 must be at least
    // as wide as the preferred width of the column data cells.
    table.setColumnWidthConstraint(1, TablePrint.CONSTRAINT_MIN_CELLS);
    table.setFitWidth(true);
    return table;
  }
  
  public static TablePrint createTable() {
    TablePrint table = new TablePrint(new MyTableDataModel());
    return table;
  }
}
