/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;
import javax.swing.*;

import li.netcat.print.*;
import li.netcat.print.table.*;
import li.netcat.print.util.*;

public class TableLineBreakExample {
  
  public static void main(String[] args)	{
    new PrintPreview(createPrint()).open();
  }

  public static Print createPrint() {
    return createTable();
  }
  
  public static TablePrint createTable() {
    TablePrint table = new TablePrint(new DinnerModelWithIcons());
    // set a centered cell drawer that paints the icon
    // note that the DinnerModelWithIcons returns this rather unusual cell type
    table.setCellDrawer("this is an icon column", table.createDefaultCellDrawer(PrintConstants.CENTER));
    // set a right aligned cell drawer that paints the numbers
    table.setCellDrawer(Number.class, table.createDefaultCellDrawer(PrintConstants.RIGHT));
    // set a right aligned footer drawer that paints the numbers
    table.setFooterDrawer(Number.class, table.createDefaultFooterDrawer(PrintConstants.RIGHT));
    // register a multi line text cell drawer for the strings.
    table.setCellDrawer(String.class, new TextTableCellDrawer());
    // make sure that the columns 0, 2, 3 and 4 dont get shrinked width.
    // Real world code would use the data model or an other source to determine the column indices.
    // But we want to keep the example simple.
    table.setColumnWeight(0, 0.0f);
    table.setColumnWeight(2, 0.0f);
    table.setColumnWeight(3, 0.0f);
    table.setColumnWeight(4, 0.0f);
    table.setFitWidth(true);
    return table;
  }
}
