/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;
import javax.swing.*;

import li.netcat.print.*;
import li.netcat.print.table.*;
import li.netcat.print.util.*;

public class TableRendererExample {
  
  public static void main(String[] args)	{
    new PrintPreview(createPrint()).open();
  }

  public static Print createPrint() {
    TablePrint table = new TablePrint(new DinnerModel());
    // set a right aligned cell drawer that paints the numbers
    // note that the DinnerModel returns Number.class for the number texts
    table.setCellDrawer(Number.class, table.createDefaultCellDrawer(PrintConstants.RIGHT));
    // set a right aligned footer drawer that paints the numbers
    table.setFooterDrawer(Number.class, table.createDefaultFooterDrawer(PrintConstants.RIGHT));
    // configure header drawer with other font
    
    //DefaultTableCellDrawer cellDrawer = table.createDefaultHeaderDrawer(PrintConstants.CENTER);
    //cellDrawer.getDrawer().setFont(new Font(null, Font.BOLD | Font.ITALIC, 16));
    //table.setDefaultHeaderDrawer(cellDrawer);
    
    // register my own table cell drawer for the text column.
    table.setCellDrawer(String.class, new MyCellDrawer());
    table.setFitWidth(true);
    return table;
  }
  
  // this example extends the DefaultTableCellDrawer that supports icons. 
  private static class MyCellDrawer extends DefaultTableCellDrawer {
    private static final Icon _ok = new ImageIcon("./images/Ok.gif");
    private static final Icon _nok = new ImageIcon("./images/Nok.gif");
      
    //// overridden methods 

    protected Icon getIcon(Object value, Object type, int rowIndex, int columnIndex) {
      // do some conversion
      if (rowIndex == 3) {
        return _nok;
      }
      return _ok;
    }
    
  }
}
